'Find and Replace routines by Charles Dietz
'Just need to add the last four functions to use in an application.
'Applies to textboxes and richedit.           
'This code is released into the Public Domain.
'-------------------------------------------------------------------------------------
                         
#COMPILE EXE                                                                            
#DIM ALL                                         
#INCLUDE "Win32api.inc"
#Include "RichEdit.inc"                
'#INCLUDE "debug.inc"      
                                
%IDM_Find     = 201                                           
%IDM_FindNext = 202                                         
%IDM_FindPrev = 203                                                                                          
%IDM_Replace  = 204                               
%IDC_Escape   = 205                                                                    
%IDC_Text     = 100                                      

FUNCTION PBMAIN()                                                         
   LOCAL hDlg, nStyle, fileNo AS LONG                                                            
   local ti, sText, ctrl as string            
   DIALOG default FONT "arial", 10
   ti = "Find and Replace for "
   DIALOG NEW 0, "", , , 354, 250, %WS_SYSMENU TO hDlg
   fileNo = FREEFILE                                                  
   OPEN "testFile.txt" FOR binary AS #fileNo                                                  
   sText = STRING$(LOF(fileNo), 0)
   GET #fileNo,, sText  'load file into string buffer
   CLOSE #fileNo
   ctrl = "textbox"
   'ctrl = "richedit"
   dialog set text hDlg, ti + ctrl                      
   nStyle = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll Or %ES_AutoVScroll _
            Or %ES_WantReturn Or %ES_NoHideSel Or %WS_TabStop
   if ctrl = "textbox" then
      CONTROL ADD TEXTBOX, hDlg, %IDC_Text, "", 0, 0, 350, 225, nStyle
      control set text hDlg, %IDC_Text, sText
   elseif ctrl = "richedit" then
      LoadLibrary("riched32.dll") : InitCommonControls
      Control Add "RichEdit", hDlg, %IDC_Text, "Try this", 0, 0, 350, 225, nStyle
      control send hDlg, %IDC_Text, %EM_ReplaceSel, 1, strptr(sText) 
   end if          
   DIALOG SHOW MODAL hDlg CALL DialogProc
END FUNCTION

CALLBACK FUNCTION dialogProc()
   LOCAL j, k AS LONG
   local hFont, gOldProc as long
   STATIC hEdit AS DWORD
   SELECT CASE CBMSG                                          
      CASE %WM_INITDIALOG
         addMenubar CBHNDL                                                                      
         hFont = makeFont("Courier New", 10)
         IF hFont THEN
             CONTROL SEND CBHNDL, %IDC_Text, %WM_SETFONT, hFont, 1
         END IF                                                            
         CONTROL HANDLE CBHNDL, %IDC_Text TO hEdit 
         CONTROL SET FOCUS CBHNDL, %IDC_Text
         control send cb.hndl, %IDC_Text, %EM_SETSEL, -1, 0  
         control send cb.hndl, %IDC_Text, %EM_SETSEL, 0, 0
         ' Subclass the edit control
         sendmessage hEdit, %EM_SETSEL, -1, 0
         gOldProc = SetWindowLong(hEdit, %GWL_WNDPROC, CODEPTR(SubClassProc))
         dialog set user cbhndl, 1, gOldProc
         dialog post cbhndl, %WM_User + 500, 0, 0
      case %WM_USEr + 500 
      CASE %WM_COMMAND
         SELECT CASE CBCTL                                                                        
            CASE %IDM_Find
               myFindReplace(hEdit)               
            CASE %IDM_FindNext 
               myFindReplace(hEdit, 3)
            CASE %IDM_FindPrev                                                                                     
               myFindReplace(hEdit, -3)
            CASE %IDM_Replace
               myFindReplace(hEdit, 1)
            case %IDC_Escape
               SendMessage hEdit, %EM_GETSEL, VARPTR(j), VARPTR(k)
               SendMessage hEdit, %EM_SETSEL, j, j
         END SELECT
      CASE %WM_DESTROY
         ' Important! Remove the subclassing
         SetWindowLong hEdit, %GWL_WNDPROC, gOldProc
   END SELECT   
END FUNCTION         

FUNCTION SubClassProc(BYVAL hWnd&, BYVAL wMsg&, BYVAL wParm&, BYVAL lParm&) AS LONG
    'Process our messages in this subclass procedure
    local lRes as long
    static gOldProc as long
    dialog get user getParent(hWnd&), 1 to gOldProc                             
    SELECT CASE wMsg&                                
       CASE %WM_GETDLGCODE         
          ' TextBoxes has a tendency to select all text when they receive
          ' focus. We can change this behaviour by altering the return
          ' value from CallWindowProc under %WM_GETDLGCODE as follows:
          lRes = CallWindowProc (gOldProc, hWnd&, wMsg&, wParm&, lParm&)
          IF (lRes AND %DLGC_HASSETSEL) = %DLGC_HASSETSEL THEN  'lRes contains %DLGC_HASSETSEL 
             lRes = lRes XOR %DLGC_HASSETSEL                    'remove %DLGC_HASSETSEL from lRes
             FUNCTION = lRes: EXIT FUNCTION                     'return the altered value and exit    
          END IF
    END SELECT
    ' Pass the message on to the original window procedure
    FUNCTION = CallWindowProc(gOldProc, hWnd&, wMsg&, wParm&, lParm&)
END FUNCTION

SUB addMenubar(hDlg AS LONG)                                                
   LOCAL hMenu, hSearchMenu, hAccel AS LONG
   MENU NEW BAR TO hMenu
   MENU NEW POPUP TO hSearchMenu
   MENU ADD STRING, hSearchMenu, "&Find" & $TAB & "Ctrl+F", %IDM_Find, %MF_ENABLED
   MENU ADD STRING, hSearchMenu, "Find &Next" & $TAB & "F3", %IDM_FindNext, %MF_ENABLED
   MENU ADD STRING, hSearchMenu, "Find &Previous" & $TAB & "Shft+F3", %IDM_FindPrev, %MF_ENABLED
   MENU ADD STRING, hSearchMenu, "&Replace" & $TAB & "Ctrl+R", %IDM_Replace, %MF_ENABLED
   MENU ADD POPUP, hMenu, "Search", hSearchMenu, %MF_ENABLED
   MENU ATTACH hMenu, hDlg
   REDIM ac(1 to 5) AS ACCELAPI
   ac(1).fvirt = %FVIRTKEY OR %FCONTROL
   ac(1).key = %VK_F
   ac(1).cmd =  %IDM_Find
   ac(2).fvirt = %FVIRTKEY
   ac(2).key = %VK_F3
   ac(2).cmd =  %IDM_FindNext
   ac(3).fvirt = %FVIRTKEY OR %FSHIFT
   ac(3).key = %VK_F3
   ac(3).cmd =  %IDM_FindPrev
   ac(4).fvirt = %FVIRTKEY OR %FCONTROL
   ac(4).key = %VK_R
   ac(4).cmd =  %IDM_Replace          
   ac(5).fvirt = %FVIRTKEY
   ac(5).key =   %VK_ESCAPE                    
   ac(5).cmd =   %IDC_Escape
   ACCEL ATTACH hDlg, ac() TO hAccel
END SUB

FUNCTION MakeFont(xFont AS STRING, ptSize AS LONG) AS LONG
   LOCAL hdc, yRes AS LONG, charHt AS LONG
   hDC = GetDC(%HWND_DESKTOP)
   yRes  = GetDeviceCaps(hdc, %LOGPIXELSY)
   ReleaseDC %HWND_DESKTOP, hDC
   charHt = (PtSize * yRes) \ 72
   FUNCTION = CreateFont(-charHt, 0, 0, 0, %FW_NORMAL, 0, 0, 0, _
              %ANSI_CHARSET, %OUT_TT_PRECIS, %CLIP_DEFAULT_PRECIS, _
              %DEFAULT_QUALITY, %FF_DONTCARE, BYCOPY xFont)
END FUNCTION
                                                                                                         
'--------------------------------------------------------------------------------------------------
'  Find and replace routines
'--------------------------------------------------------------------------------------------------

FUNCTION myFind(hText AS LONG, findTxt AS STRING, whole AS LONG, ncase AS LONG, ndir AS LONG) AS LONG 
   'this function finds and returns the next position of the search string
   'hText   = handle of control holding the text to be searched
   'findTxt = string to be searched for                                               
   'whole, ncase, cycleBeep, ndir are options to be used
   '------------------------------------------------------------------------------------- 
   LOCAL j, k, n, nPos, done AS LONG                                                                                   
   LOCAL sText, s1, s2 AS STRING                                                                               
   
   n = GetWindowTextLength(hText)+1: sText = SPACE$(n)                 
   SendMessage hText, %WM_GETTEXT, n, STRPTR(sText)
   SendMessage hText, %EM_GETSEL, VARPTR(j), VARPTR(k)                       
   IF LEN(findTxt) = 0 THEN function = j + 1: exit function
   nPos = k + 1
   IF ndir < 0 THEN nPos = j - LEN(sText) - 1            
   DO 'until whole word is found
      IF ncase THEN                                    
         nPos = INSTR(nPos, sText, findTxt)                          'search matching case
      ELSE
         nPos = INSTR(nPos, lCASE$(sText), lCASE$(findTxt))          'search any case
      END IF
      done = 1
      IF whole AND nPos THEN                                         'must be whole word
         s1 = MID$(sText, nPos - 1, 1)                               'previous character
         s2 = MID$(sText, nPos + LEN(findTxt), 1)                    'next character
         IF (s1 >= "A" AND s1 <= "Z") OR (s1 >= "a" AND s1 <= "z") OR _         
            (s2 >= "A" AND s2 <= "Z") OR (s2 >= "a" AND s2 <= "z") OR _
            (s1 >= "0" AND s1 <= "9") OR (s2 >= "0" AND s2 <= "9") OR _
            s1 = "_" OR s2 = "_" THEN
            done = 0: nPos = nPos + ndir
            if ndir < 0 then nPos = -(LEN(sText) + 1 - nPos)
         END IF
      END IF 
   LOOP UNTIL done
   FUNCTION = nPos
END FUNCTION
 
FUNCTION myFindReplace(hhText AS LONG, opt byval nOpt AS LONG) AS LONG                                        
   'this function sets up the find and replace dialog window
   'it is also where all of the searching takes place                                                         
   'nOpt =  0  find dialog
   '     =  1  replace dialog                    
   '     =  3  find next
   '     = -3  find prev
   '
   'changed options in dialog box are remembered 
   'pass parameters to callback and back with parms(7)
   'option to cycle between top and end of text
'----------------------------------------------------------------------   
   LOCAL hFindRepl, j, k, n AS LONG
   local s as string
   static hText as long                                           
   STATIC nPos, whole, ncase, alreadyBeenHere as long                                                       
   static ndir, beginLoc, cycleBeep, replaceDlg AS LONG                                                       
   static ti, sText, findTxt, lastFindTxt AS STRING                                        
   static parmsPtr as long ptr
   DIM parms(1 to 7) AS LONG: parmsPtr = VARPTR(parms(1))
   hText = hhText
   if alreadyBeenHere = 0 then 'first time through, set defaults
      alreadyBeenHere = 1: whole = 1: ncase = 0: cycleBeep = 0: beginLoc = -2
   end if
   n = GetWindowTextLength(hText)+1: sText = SPACE$(n)
   SendMessage hText, %WM_GETTEXT, n, STRPTR(sText)                                                                     
   SendMessage hText, %EM_GETSEL, VARPTR(j), VARPTR(k)                                    
   findTxt = MID$(sText, j + 1, k - j): lastFindTxt = findTxt
   IF abs(nOpt) = 3 THEN 'find next
      if ndir * sgn(nOpt) < 0 then cycleBeep = 0: beginLoc = -2
      ndir = sgn(nOpt)
      nPos = myFind(hText, findTxt, whole, ncase, ndir)
      if nPos = beginLoc then beep
      if nPos = 0 then 'reset to top or end                                                    
         if ndir < 0 then n = len(sText) else n = 0                                                                     
         SendMessage hText, %EM_SETSEL, n, n                                                                 
         nPos = myFind(hText, findTxt, whole, ncase, ndir)
         if nPos = beginLoc then beep
      end if
      DECR nPos
      SendMessage hText, %EM_SETSEL, nPos, nPos + LEN(findTxt)                                       
      SendMessage hText, %EM_SCROLLCARET, 0, 0                                                  
      EXIT FUNCTION                        
   ELSEIF nOpt = 1 THEN 'show replace dialog                    
      ti = "Replace": replaceDlg = 1: nPos = 0
   ELSEif nOpt = 0 then 'show find dialog                  
      ti = "Find": replaceDlg = 0
   END IF                                                         
   ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''                                         
   if replaceDlg then 'find and replace dialog
      DIALOG NEW getParent(hText), ti, , , 250, 110, %WS_SYSMENU TO hFindRepl
      CONTROL ADD LABEL, hFindRepl, -1, "&What:", 10, 10, 25, 10
      CONTROL ADD TEXTBOX, hFindRepl, 9700, "", 40, 10, 140, 12                             
      CONTROL ADD LABEL, hFindRepl, -1, "&With:", 10, 30, 25, 10
      CONTROL ADD TEXTBOX, hFindRepl, 9701, "", 40, 30, 140, 12                                
      CONTROL ADD CHECKBOX, hFindRepl, 9702, "&Match whole word", 10, 49, 70, 10                  
      CONTROL ADD CHECKBOX, hFindRepl, 9703, "Match &case", 10, 62, 50, 10
      CONTROL ADD CHECKBOX, hFindRepl, 9706, "&Beep on cycle", 10, 75, 58, 10
      CONTROL ADD FRAME, hFindRepl, -1, "Direction", 110, 50, 60, 36
      CONTROL ADD OPTION, hFindRepl, 9704, "&Up", 115, 60, 40, 10
      CONTROL ADD OPTION, hFindRepl, 9705, "&Down", 115, 70, 40, 10                                        
      CONTROL ADD BUTTON, hFindRepl, %IDOK, "&Find", 190, 5, 50, 20, %BS_DEFAULT 'or %bs_notify
      CONTROL ADD BUTTON, hFindRepl, 9708, "&Replace", 190, 27, 50, 20
      CONTROL ADD BUTTON, hFindRepl, 9709, "Replace &All", 190, 49, 50, 20                                         
      CONTROL ADD BUTTON, hFindRepl, %IDCANCEL, "Cancel", 190, 71, 50, 20                           
   else                                                                                            
      s = findTxt: if len(s) = 0 then s = lastFindTxt
      DIALOG NEW getParent(hText), ti, , , 250, 90, %WS_SYSMENU TO hFindRepl                                                                                           
      CONTROL ADD LABEL, hFindRepl, -1, "&What:", 10, 10, 25, 10
      CONTROL ADD TEXTBOX, hFindRepl, 9700, s, 40, 10, 140, 12                             
      CONTROL ADD CHECKBOX, hFindRepl, 9702, "&Match whole word", 10, 32, 70, 10
      CONTROL ADD CHECKBOX, hFindRepl, 9703, "Match &case", 10, 45, 50, 10
      CONTROL ADD CHECKBOX, hFindRepl, 9706, "&Beep on cycle", 10, 58, 58, 10
      CONTROL ADD FRAME, hFindRepl, -1, "Direction", 110, 30, 60, 36
      CONTROL ADD OPTION, hFindRepl, 9704, "&Up", 115, 40, 40, 10
      CONTROL ADD OPTION, hFindRepl, 9705, "&Down", 115, 50, 40, 10
      CONTROL ADD BUTTON, hFindRepl, %IDOK, "&Find", 190, 5, 50, 20, %BS_DEFAULT 'or %bs_notify                     
      CONTROL ADD BUTTON, hFindRepl, %IDCANCEL, "Cancel", 190, 45, 50, 20
   END IF
   @parmsPtr[1] = hText: @parmsPtr[2] = whole: @parmsPtr[3] = ncase: @parmsPtr[4] = cycleBeep
   @parmsPtr[5] = replaceDlg: @parmsPtr[6] = beginLoc: @parmsPtr[7] = ndir
   DIALOG SET USER hFindRepl, 1, parmsPtr
'   DIALOG SHOW modal hFindRepl CALL findReplaceProc to parmsPtr
   DIALOG SHOW modeless hFindRepl CALL findReplaceProc to parmsPtr              
   DO
      DIALOG DOEVENTS                                                                                        
   LOOP WHILE ISWIN(hFindRepl)
   hText = @parmsPtr[1]: whole = @parmsPtr[2]: ncase = @parmsPtr[3]: cycleBeep = @parmsPtr[4] 
   replaceDlg = @parmsPtr[5]: beginLoc = @parmsPtr[6]: ndir = @parmsPtr[7]
END FUNCTION                                                                        
                                       
CALLBACK FUNCTION findReplaceProc()                                                                       
   LOCAL j, k, m, n, nnPos, nPre, testForDone, selFlag, hAccel  AS LONG       
   LOCAL s, sFind AS STRING                                                        
   STATIC hText, whole, ncase, cycleBeep, ndir, lastDir as long 
   static replaceDlg, beginLoc, nPos, found AS LONG
   static findTxt, replaceTxt, lastFindTxt, lastReplaceTxt, sText as string        
   STATIC parmsPtr AS LONG PTR                                                              
   SELECT CASE CBMSG                                                          
      CASE %WM_INITDIALOG                                                                 
         DIALOG GET USER CBHNDL, 1 TO parmsPtr                                                        
         hText = @parmsPtr[1]: whole = @parmsPtr[2]: ncase = @parmsPtr[3]: cycleBeep = @parmsPtr[4]
         replaceDlg = @parmsPtr[5]: beginLoc = @parmsPtr[6]: ndir = @parmsPtr[7]
         n = GetWindowTextLength(hText)+1: sText = SPACE$(n)
         SendMessage hText, %WM_GETTEXT, n, STRPTR(sText)    'text to search in
         SendMessage hText, %EM_GETSEL, VARPTR(j), VARPTR(k)
         findTxt = MID$(sText, j + 1, k - j)
         if j = k then control disable cbhndl, 9708
         if len(findtxt) = 0 then findTxt = lastFindTxt: selFlag = 1 
         control send cbhndl, 9701, %EM_SETSEL, 0, -1                                      
         CONTROL SET TEXT CBHNDL, 9700, findTxt    'text to search for
         if selFlag then control post cbhndl, 9700, %EM_SETSEL, 0, -1
         if replaceDlg then
            if j = k then control disable cbhndl, 9708
            replaceTxt = lastReplaceTxt
            CONTROL SET TEXT CBHNDL, 9701, replaceTxt    
            control post cbhndl, 9701, %EM_SETSEL, 0, -1
            if len(findTxt) and selFlag = 0 then control set focus cbhndl, 9701                
         end if
         CONTROL sET CHECK CBHNDL, 9702, whole              
         CONTROL sET CHECK CBHNDL, 9703, ncase                                     
         CONTROL sET CHECK CBHNDL, 9706, cycleBeep
         CONTROL SET OPTION cbhndl, 9705, 9704, 9705                              
         REDIM ac(1 to 3) AS ACCELAPI
         ac(1).fvirt = %FVIRTKEY
         ac(1).key =   %VK_F3                                          
         ac(1).cmd =   9711 'findNext
         ac(2).fvirt = %FVIRTKEY OR %FSHIFT                  
         ac(2).key =   %VK_F3                           
         ac(2).cmd =   9712 'findPrev
         ac(3).fvirt = %FVIRTKEY
         ac(3).key =   %VK_ESCAPE                    
         ac(3).cmd =   9710 'escape
         ACCEL ATTACH cbhndl, ac() TO hAccel
      CASE %WM_COMMAND         
         select case cbctl                          
            case %IDOK 'find next text
               CONTROL GET TEXT CBHNDL, 9700 TO findTxt         
               if len(findTxt) = 0 then
                  msgbox "Must enter something to find", %MB_iconerror, "Error"         
                  control set focus cbhndl, 9700: exit function                           
               end if
               lastFindTxt = findTxt
               control get check cbhndl, 9705 to ndir
               if ndir = 0 then ndir = -1
               if ndir * lastDir < 0 then 'cannot change direction for cycle beeps
                  beginLoc = -2: control set check cbhndl, 9706, 0
               end if 
               lastDir = ndir              
               IF replaceDlg THEN 'replace dialog                                  
                  nnPos = nPos                                       
                  nPos = myFind(hText, findTxt, whole, ncase, ndir)
                  if nPos = beginLoc then beep
                  if beginLoc = -1 then beginLoc = nPos: nnPos = nPos
                  if nPos = 0 then 'reset to top or end 
                     if ndir < 0 then n = len(sText) else n = 0                         
                     SendMessage hText, %EM_SETSEL, n, n                                                     
                     nPos = myFind(hText, findTxt, whole, ncase, ndir)
                     if nPos = beginLoc then beep  
                     if beginLoc = -1 then beginLoc = nPos: nnPos = nPos
                     if nPos = 0 then 'searched from top to bottom, still none
                        s = "None found"
                        if found then s = "No more to replace"
                        msgbox s, %mb_iconinformation, findTxt
                        SendMessage hText, %EM_SETSEL, nnPos, nnPos 
                        SendMessage hText, %EM_SCROLLCARET, 0, 0                                                  
                        found = 0: lastReplaceTxt = ""
                        exit function        
                     end if   
                  end if
                  'check if findTxt is contained in replaceTxt and if replacement  
                  'has already been done here... and if so, move to the next 
                  if tally(lcase$(replaceTxt), lcase$(findTxt)) and (len(findTxt) < len(replaceTxt)) then
                     nPre = instr(lcase$(replaceTxt), lcase$(findTxt)) - 1
                     if nPos > nPre and len(replaceTxt) then
                        s = mid$(sText, nPos - nPre, len(replaceTxt))
                        m = ncase and (s = replaceTxt)
                        n = (ncase = 0) and (lcase$(s) = lcase$(replaceTxt))
                        if m or n then                               
                           if ndir > 0 then nPos = nPos + len(findTxt) - 1
                           SendMessage hText, %EM_SETSEL, nPos, nPos
                           DIALOG SEND CBHNDL, %WM_COMMAND, %IDOK, 0
                           exit function
                        end if
                     end if
                  end if
                  DECR nPos: found = 1 
                  SendMessage hText, %EM_SETSEL, nPos, nPos + LEN(findTxt)                                       
                  SendMessage hText, %EM_SCROLLCARET, 0, 0                                                  
                  control enable cbhndl, 9708 
                  exit function
               else 'find dialog
                  nnPos = nPos      
                  nPos = myFind(hText, findTxt, whole, ncase, ndir)
                  if nPos = beginLoc then beep
                  if beginLoc = -1 then beginLoc = nPos: nnPos = nPos
                  if nPos = 0 then 'reset to top or end and search from there 
                     if ndir < 0 then n = len(sText) else n = 0
                     SendMessage hText, %EM_SETSEL, n, n                           
                     nPos = myFind(hText, findTxt, whole, ncase, ndir)
                     if nPos = beginLoc then beep            
                     if beginLoc = -1 then beginLoc = nPos: nnPos = nPos
                     if nPos = 0 then
                        msgbox "None found", %mb_iconinformation, findTxt
                        exit function                                            
                     end if
                  end if 
                  DECR nPos: found = 1                                                                   
                  SendMessage hText, %EM_SETSEL, nPos, nPos + LEN(findTxt)                                       
                  SendMessage hText, %EM_SCROLLCARET, 0, 0 
               end if
            case 9702 'whole
               CONTROL GET CHECK CBHNDL, cbctl TO whole
            case 9703 'ncase
               CONTROL GET CHECK CBHNDL, cbctl TO ncase                                             
            case 9704, 9705 'search up/down
               control get check cbhndl, 9705 to ndir  'search down
               if ndir = 0 then ndir = -1
            case 9711 '%IDM_FindNext
               CONTROL SET OPTION cbhndl, 9705, 9704, 9705
               DIALOG SEND CBHNDL, %WM_COMMAND, %IDOK, 0 
            case 9712 '%IDM_FindPrev     
               CONTROL SET OPTION cbhndl, 9704, 9704, 9705
               DIALOG SEND CBHNDL, %WM_COMMAND, %IDOK, 0 
            case 9706 'cycle beep 
               if cbctlmsg = %bn_clicked then                         
                  control get check cbhndl, cbctl to cycleBeep
                  'beginLoc = -1: set beginning location at next find
                  'otherwise, set beginning location to start of selection
                  if cycleBeep then  
                     SendMessage hText, %EM_GETSEL, VARPTR(j), VARPTR(k)
                     if j <> k then beginLoc = j + 1 else beginLoc = -1
                  else
                     beginLoc = -2  'cannot be any beginning location   
                  end if
               end if                                
            case 9708 'replace this one 
               SendMessage hText, %EM_GETSEL, VARPTR(j), VARPTR(k)
               CONTROL GET TEXT CBHNDL, 9700 TO findTxt      'get text to replace
               CONTROL GET TEXT CBHNDL, 9701 TO replaceTxt   'get replacement text                             
               if len(replaceTxt) = 0 then
                  msgbox "Must enter a replacement", %MB_iconerror, "Error"
                  control set focus cbhndl, 9701: exit function                       
               end if                                                                          
               lastFindTxt = findTxt: lastReplaceTxt = replaceTxt                     
               control send cbhndl, 9701, %BM_SETSTYLE, %BS_DEFPUSHBUTTON, 1
               sText = LEFT$(sText, j) + replaceTxt + MID$(sText, k + 1)
               SendMessage hText, %WM_SETTEXT, 0, STRPTR(sText)
               if j < beginLoc then beginLoc = beginLoc + len(replaceTxt) - len(findTxt)
               
               'if findTxt is contained in replaceTxt then count remaining replacements 
               if tally(lcase$(replaceTxt), lcase$(findTxt)) and (len(findTxt) < len(replaceTxt)) then
                  m = unreplaced(hText, findTxt, replaceTxt, whole, ncase)
                  if m = 0 then 'no unreplaced remain 
                     msgbox "... No more to replace", %MB_iconinformation, findTxt         
                     SendMessage hText, %EM_SETSEL, nPos, nPos
                     SendMessage hText, %EM_SCROLLCARET, 0, 0
                     lastReplaceTxt = "": exit function
                  end if
               end if                                                                                       

               if ndir > 0 then n = j + LEN(replaceTxt) else n = j 
               SendMessage hText, %EM_SETSEL, n, n
               DIALOG SEND CBHNDL, %WM_COMMAND, %IDOK, 0                                                  
            case 9709 'replace all of them
               CONTROL GET TEXT CBHNDL, 9700 TO findTxt
               CONTROL GET TEXT CBHNDL, 9701 TO replaceTxt
               if len(findTxt) = 0 or len(replaceTxt) = 0 then
                  s = "Must enter something to find " + $crlf _
                    + "and something to replace it with"                              
                  msgbox s, %MB_iconerror, "Error"
                  if len(findTxt) = 0 then control set focus cbhndl, 9700: exit function
                  if len(replaceTxt) = 0 then control set focus cbhndl, 9701: exit function
               end if 
               lastFindTxt = findTxt: lastReplaceTxt = replaceTxt
               s = "Be carefull here!" + $crlf + "... Are you sure you want to replace all?"        
               n = msgbox(s, %MB_ICONWARNING or %Mb_yesno, "Replacing text")
               if n = %idno then function = 1: exit function                                                       
               nPos = 0: ndir = 1                                                            
               DO                                                                                                     
                  SendMessage hText, %EM_SETSEL, nPos, nPos
                  nPos = myFind(hText, findTxt, whole, ncase, ndir) - 1
                  SendMessage hText, %EM_SETSEL, nPos, nPos + LEN(findTxt)
                  incr nPos: 
                  IF nPos THEN
                     SendMessage hText, %EM_ReplaceSel, 1, BYVAL STRPTR(replaceTxt)
                     nPos = nPos + len(replaceTxt): found = 1
                  END IF 
               LOOP WHILE nPos 
               DIALOG END CBHNDL, parmsPtr                                       
               nPos = 0: SendMessage hText, %EM_SETSEL, nnPos, nnPos 
               if found then                                                       
                  msgbox "Done replacing text", %MB_iconinformation, findTxt
               else                                                                               
                  msgbox "Nothing found to replace", %MB_iconerror, findTxt
               end if                                                                       
            case 9710 '%IDC_Escape
               SendMessage hText, %EM_SETSEL, 0, 0
               dialog end cbhndl, parmsPtr 
            case %IDCANCEL, %IDC_Escape
               @parmsPtr[1] = hText: @parmsPtr[2] = whole: @parmsPtr[3] = ncase: @parmsPtr[4] = cycleBeep
               @parmsPtr[5] = replaceDlg: @parmsPtr[6] = beginLoc: @parmsPtr[7] = ndir
               DIALOG END CBHNDL, parmsPtr                                                        
         end select                                                                  
      case %wm_destroy
         setFocus(hText)                                                                     
      CASE %WM_SYSCOMMAND
         IF CBCTL = %SC_CLOSE THEN DIALOG END CBHNDL, parmsPtr
   END SELECT                                                     
END FUNCTION
                                                                                    
function unreplaced(hText as long, findTxt as string, replaceTxt as string,_ 
                    whole as long, ncase as long) as long
   '------------------------------------------------------------------------- 
   'scan text beginning to end, counting number of replacements remaining
   '-------------------------------------------------------------------------                
   local nPos, nPre, flag, n, k as long                 
   local s, sText as string 
   n = GetWindowTextLength(hText)+1: sText = SPACE$(n)                 
   SendMessage hText, %WM_GETTEXT, n, STRPTR(sText)
   nPre = instr(lcase$(replaceTxt), lcase$(findTxt)) - 1
   SendMessage hText, %EM_SETSEL, 0, 0
   do 
      nPos = myFind(hText, findTxt, whole, ncase, 1)
      if nPos = 0 then exit loop
      if nPos > nPre and len(replaceTxt) then                                
         s = mid$(sText, nPos - nPre, len(replaceTxt))
         if ncase then
            if s <> replaceTxt then flag = 1: incr k
         else 
            if lcase$(s) <> lcase$(replaceTxt) then flag = 1: incr k
         end if                                                                           
      else 
         flag = 1: incr k
      end if
      if flag then n = nPos + len(findtxt) else n = nPos - nPre + len(replaceTxt)
      decr n: SendMessage hText, %EM_SETSEL, n, n
   loop until nPos = 0
   function = k                                                   
end function   
